/*
 * exn.c
 * Exception handling routines and internal status
 */

#include <setjmp.h>
#include <string.h>

#include "exn.h"
#include "config.h"

static jmp_buf _exn_handler;

struct exn exn_current;

void _exn_setHandler(jmp_buf *handler) {
  memcpy(&_exn_handler, handler, sizeof(jmp_buf));
}

void _exn_swapHandler(jmp_buf *handler) {
  jmp_buf tmp;
  memcpy(&tmp, &_exn_handler, sizeof(jmp_buf));
  memcpy(&_exn_handler, handler, sizeof(jmp_buf));
  memcpy(handler, &tmp, sizeof(jmp_buf));
}

void _exn_throw(int line, const char *file, int code, const char *msg) {
  exn_current.line = line;
  exn_current.file = file;
  exn_current.code = code;
  exn_current.msg = msg;
  longjmp(_exn_handler, 1);
}

void exn_rethrow(void) {
  longjmp(_exn_handler, 1);
}

/* vim:set shiftwidth=2 softtabstop=2: */
