/*
 * nc_check.c
 * The NetCDF error check function.
 */

#include <stdio.h>
#include <netcdf.h>

#include "nc_check.h"
#include "exn.h"
#include "utils.h"
#include "config.h"

char _nc_msg[NC_MSG_MAX];

void _nc_check(int rc, int line, const char *file, const char *msg) {
  if (rc != NC_NOERR) {
    snprintf(_nc_msg, NC_MSG_MAX, "%s: %s", msg, nc_strerror(rc));
    _exn_throw(line, file, EXN_CODE_NETCDF, _nc_msg);
  }
}

/* vim:set shiftwidth=2 softtabstop=2: */
