/*!
 * @header NetCDF Check
 * Small helper to throw exceptions on NetCDF errors.
 */

#ifndef __NC_CHECK__
#define __NC_CHECK__

/*
 * Don't use directly
 */
#define NC_MSG_MAX 1024
extern char _nc_msg[NC_MSG_MAX];

/*
 * Don't use directly
 */
void _nc_check(int rc, int line, const char *file, const char *msg);

/*!
 * @define NC_CHECK
 * Check the return code of a NetCDF function and throw an exception
 * in case of error.
 * @param rc the return code of the function
 * @param msg message for the exception in case of error
 */
#define NC_CHECK(rc, msg) _nc_check((rc), __LINE__, __FILE__, (msg))

#endif /* __NC_CHECK__ */

/* vim:set shiftwidth=2 softtabstop=2: */
